// Attempt mirroRed clusteRed spheres

#include "colors.inc" 
#include "stones.inc"

#declare Copper  = rgb <0.84,0.04,0.15>;
#declare Orange1 = rgb <1.00,0.16,0.00>;
#declare Orange2 = rgb <1.00,0.35,0.00>;
#declare Purple1 = rgb <0.87,0.00,1.00>;
#declare Purple2 = rgb <1.00,0.14,1.00>;
#declare Purple3 = rgb <0.82,0.00,0.82>;
#declare Green1  = rgb <0.45,0.91,0.00>;
#declare Brown1  = rgb <0.52,0.19,0.00>;
#declare Silver  = rgb <0.80,0.80,0.80>;

camera {
  location <0,0,-58>
  look_at <0,0,0>
  right <1.33333,0,0>
}

light_source {
   <20,50,-100>
   color White
}

light_source {
   <-20,-50,-100>
   color White
}


#declare F_Glass =
  finish {
    specular 0.7
    roughness 0.001
    ambient .1
    diffuse .5
    reflection { 0.9 }
  }

// A plane with a stone finish
#declare myfloor = object {  
  plane {
    y,
    -100.0
    texture {
      T_Stone26
      finish { F_Glass }
      scale 1250
    }
  }  
}

#declare Sphere1 = object {
  sphere {<0,0,0> 1.25 }
  pigment { color Green1 }
  finish { 
    reflection 0.5
    brilliance 100.0
    phong 0.9
    phong_size 100
  }
}

#declare Sphere2 = object {
  sphere {<0,0,0> 2.5 }
  pigment { color Orange1 }
  finish {
    reflection 0.5
    brilliance 20.0
    phong 0.9
    phong_size 100
  }
}  

#declare Sphere3 = object {
  sphere {<0,0,0> 5 }
  pigment { color Red }
  finish {
    reflection 0.75
    brilliance 20.0
    phong 0.9
    phong_size 100
  }
}

#declare Sphere4 = object {
  sphere {<0,0,0> 10 }
  pigment { color Copper }
  finish {
    reflection 0.5
    brilliance 10.0
    phong 0.9
    phong_size 100
  }
}

#declare small_cluster = composite {
  
  object {Sphere2 }

  object {Sphere1 translate <-3.75,0,0> }
  object {Sphere1 translate < 3.75,0,0> }
  object {Sphere1 translate < 0,-3.75,0> }
  object {Sphere1 translate < 0,3.75,0> }
  object {Sphere1 translate < 0,0,-3.75> }
}

#declare medium_cluster = composite {

  object {Sphere3 }

  composite { small_cluster
    rotate <0,90,0> translate <-7.5,0,0>
  }
  composite { small_cluster
    rotate <0,-90,0> translate <7.5,0,0>
  }
  composite { small_cluster
    translate <0,0,-7.5>
  }
  composite { small_cluster
    rotate <90,0,0> translate <0,7.5,0>
  }
  composite { small_cluster
    rotate <-90,0,0> translate <0,-7.5,0>
  }
}


#declare large_cluster = composite {

  object {Sphere4 }

  composite { medium_cluster
    rotate <0,-90,0> translate <-15,0,0>
  }
  composite { medium_cluster
    rotate <0,90,0> translate <15,0,0>
  }
/*
  composite { medium_cluster
    translate <0,0,-15>
  }
*/
  composite { medium_cluster
    rotate <90,0,0> translate <0,15,0>
  }
  composite { medium_cluster
    rotate <-90,0,0> translate <0,-15,0>
  }
  composite { medium_cluster
    rotate <180,0,0> translate <0,0,15>
  }
}

// Define the scene
object { myfloor }
composite { large_cluster no_shadow scale <1.1,1,1.2> }











