// Attempt mirroRed clusteRed spheres

#include "colors.inc"

#declare Copper  = rgb <0.84,0.04,0.15>;
#declare Orange1 = rgb <1.00,0.16,0.00>;
#declare Orange2 = rgb <1.00,0.35,0.00>;
#declare Purple1 = rgb <0.87,0.00,1.00>;
#declare Purple2 = rgb <1.00,0.14,1.00>;
#declare Purple3 = rgb <0.82,0.00,0.82>;
#declare Green1  = rgb <0.45,0.91,0.00>;
#declare Brown1  = rgb <0.52,0.19,0.00>;
#declare Silver  = rgb <0.80,0.80,0.80>;

camera {
  location <0,0,-50>
  look_at <0,0,0>
  right <1.33333,0,0>
}

light_source {
   <100,100,-100>
   color White
}

light_source {
   <-100,-100,-100>
   color White
}

object {
  sphere { <0,0,0>, 500 hollow }
  finish { reflection 0.1 }
  pigment
  { magnet 2 mandel 300
    color_map
      { [0 rgb 0]
        [.3 rgb <.8,.4,.1>]
        [.6 rgb <1,.8,.4>]
        [1 rgb 0]
      }
    interior 1,2000
    translate <-1.0693285,0.69524>
    scale 1000000
  }
  finish { ambient 1 }
}

#declare Sphere1 = object {
  sphere {<0,0,0> 1.25 }
  pigment { color Green1 }
  finish { 
    reflection 0.5
    brilliance 25.0
    phong 0.9
    phong_size 200
  }
}

#declare Sphere2 = object {
  sphere {<0,0,0> 2.5 }
  pigment { color Orange1 }
  finish {
    reflection 0.5
    brilliance 25.0
    phong 0.9
    phong_size 200
  }
}  

#declare Sphere3 = object {
  sphere {<0,0,0> 5 }
  pigment { color Red }
  finish {
    reflection 0.5
    brilliance 25.0
    phong 0.9
    phong_size 200
  }
}

#declare Sphere4 = object {
  sphere {<0,0,0> 10 }
  pigment { color Copper }
  finish {
    reflection 0.5
    brilliance 25.0
    phong 0.9
    phong_size 200
  }
}

#declare small_cluster = composite {
  
  object {Sphere2 }

  object {Sphere1 translate <-3.75,0,0> }
  object {Sphere1 translate < 3.75,0,0> }
  object {Sphere1 translate < 0,-3.75,0> }
  object {Sphere1 translate < 0,3.75,0> }
  object {Sphere1 translate < 0,0,-3.75> }
}

#declare medium_cluster = composite {

  object {Sphere3 }

  composite { small_cluster
    rotate <0,90,0> translate <-7.5,0,0>
  }
  composite { small_cluster
    rotate <0,-90,0> translate <7.5,0,0>
  }
  composite { small_cluster
    translate <0,0,-7.5>
  }
  composite { small_cluster
    rotate <90,0,0> translate <0,7.5,0>
  }
  composite { small_cluster
    rotate <-90,0,0> translate <0,-7.5,0>
  }
}


#declare large_cluster = composite {

  object {Sphere4 }

  composite { medium_cluster
    rotate <0,-90,0> translate <-15,0,0>
  }
  composite { medium_cluster
    rotate <0,90,0> translate <15,0,0>
  }
/*
  composite { medium_cluster
    translate <0,0,-15>
  }
*/
  composite { medium_cluster
    rotate <90,0,0> translate <0,15,0>
  }
  composite { medium_cluster
    rotate <-90,0,0> translate <0,-15,0>
  }
  composite { medium_cluster
    rotate <180,0,0> translate <0,0,15>
  }
  scale x*1.1
}

// The complete scene

composite { large_cluster no_shadow translate <0,0,10> }

/*
composite { large_cluster no_shadow translate <-80,0,160> }
composite { large_cluster no_shadow translate <+80,0,160> }

composite { large_cluster no_shadow translate <-42,0,15> }
composite { large_cluster no_shadow translate <+42,0,15> }

composite { large_cluster no_shadow rotate z*45 translate <-72,100,200> }
composite { large_cluster no_shadow rotate z*45 translate <+72,100,200> }
composite { large_cluster no_shadow rotate z*45 translate <-62,-80,170> }
composite { large_cluster no_shadow rotate z*45 translate <+62,-80,170> }
*/










