// Attempt mirroRed clusteRed spheres

#include "colors.inc"

#declare Copper  = rgb <0.84,0.04,0.15>;
#declare Orange1 = rgb <1.00,0.16,0.00>;
#declare Orange2 = rgb <1.00,0.35,0.00>;
#declare Purple1 = rgb <0.87,0.00,1.00>;
#declare Purple2 = rgb <1.00,0.14,1.00>;
#declare Purple3 = rgb <0.82,0.00,0.82>;
#declare Green1  = rgb <0.45,0.91,0.00>;
#declare Brown1  = rgb <0.52,0.19,0.00>;
#declare Silver  = rgb <0.80,0.80,0.80>;

camera {
ultra_wide_angle
  location <0,0,-28>
  look_at <0,0,0>
  right x*image_width/image_height
}

light_source {
   <100,80,-100>
   color White
}

light_source {
   <-100,-80,-100>
   color White
}

object {
  sphere { <0,0,0>, 500 hollow }
  texture {
    pigment {
      granite
      color_map {
        [0.00 0.76 color Black  color Black]
        [0.80 0.82 color Gray20 color Gray40]
        [0.82 0.84 color Gray40 color Gray60]
        [0.84 0.86 color Gray60 color Gray80]
        [0.86 0.88 color Gray80 color Gray95]
        [0.88 0.91 color Gray95 color White]
        [0.91 1.00 color Black  color Black]
      }
      scale 20
    }
    finish { ambient 1 diffuse 0 }
  }
}

#declare Sphere1 = object {
  sphere {<0,0,0> 1.25 }
  pigment { color Copper }
  finish { 
    reflection 0.6
    brilliance 25.0
    phong 0.9
    phong_size 200
  }
}

#declare Sphere2 = object {
  sphere {<0,0,0> 2.5 }
  pigment { color Green1 }
  finish {
    reflection 0.6
    brilliance 25.0
    phong 0.9
    phong_size 200
  }
}  

#declare Sphere3 = object {
  sphere {<0,0,0> 5 }
  pigment { color Red }
  finish {
    reflection 0.6
    brilliance 25.0
    phong 0.9
    phong_size 200
  }
}

#declare Sphere4 = object {
  sphere {<0,0,0> 10 }
  pigment { color Green1 }
  finish {
    reflection 0.6
    brilliance 25.0
    phong 0.9
    phong_size 200
  }
}

#declare small_cluster = composite {
  
  object {Sphere2 }

  object {Sphere1 translate <-3.75,0,0> }
  object {Sphere1 translate < 3.75,0,0> }
  object {Sphere1 translate < 0,-3.75,0> }
  object {Sphere1 translate < 0,3.75,0> }
  object {Sphere1 translate < 0,0,-3.75> }
}

#declare medium_cluster = composite {

  object {Sphere3 }

  composite { small_cluster
    rotate <0,90,0> translate <-7.5,0,0>
  }
  composite { small_cluster
    rotate <0,-90,0> translate <7.5,0,0>
  }
  composite { small_cluster
    translate <0,0,-7.5>
  }
  composite { small_cluster
    rotate <90,0,0> translate <0,7.5,0>
  }
  composite { small_cluster
    rotate <-90,0,0> translate <0,-7.5,0>
  }
}


#declare large_cluster = composite {

  object {Sphere4 }

  composite { medium_cluster
    rotate <0,-90,0> translate <-15,0,0>
  }
  composite { medium_cluster
    rotate <0,90,0> translate <15,0,0>
  }

  composite { medium_cluster 
    translate <0,0,-15>
  }

  composite { medium_cluster
    rotate <90,0,0> translate <0,15,0>
  }
  composite { medium_cluster
    rotate <-90,0,0> translate <0,-15,0>
  }
  composite { medium_cluster
    rotate <180,0,0> translate <0,0,15>
  }
}

// The complete scene

composite { large_cluster no_shadow rotate z*45 translate <0,0,10> }
composite { large_cluster no_shadow scale y*20 rotate -z*45 translate <-135,100,170> }
composite { large_cluster no_shadow scale y*20 rotate +z*45 translate <+135,100,170> }
composite { large_cluster no_shadow scale y*20 rotate +z*45 translate <-135,-100,170> }
composite { large_cluster no_shadow scale y*20 rotate -z*45 translate <+135,-100,170> }
