// Reflecting cones
// Scene by: Craig Lindley
// Last Update: 09/25/06

#include "colors.inc"

// Camera specification
camera {
  location <0,0,-10>
  right x*image_width/image_height
  look_at <0,0,0>
}

// Define the light sources
light_source {
   <-3,3,-3>
   color Gold
}
light_source {
   <3,-3,-3>
   color Blue
}

// Cone parameters
#declare cone_radius = 5;
#declare cone_height = 12;

// Highly reflective finish
declare cone_finish =

finish {
  ambient 0.03
  diffuse 1
  brilliance 50
  specular 1
  reflection 1
  phong 1 
  phong_size 100
  metallic
}

#declare pointed_cone =
  cone {
    cone_height*y, cone_radius,
    0*y, 0
    texture {
      pigment {
        color <1,1,1>
      }
      finish {
        cone_finish
      }
    }
  }
    

// Define the four cones
#declare cone1 =
  cone { 
    pointed_cone 
    scale 10
    rotate x*90 
    translate z*1
   }

#declare cone2 =
  cone { 
    pointed_cone
    translate y*1
   }

#declare cone3 =
  cone { 
    pointed_cone
    rotate x*-180
    translate y*-1
   }

#declare cone4 =
  cone { 
    pointed_cone
    rotate z*90 
    translate x*-1
   }

#declare cone5 =
  cone { 
    pointed_cone
    rotate z*-90 
    translate x*1
   }

#declare cones = 
  composite {
    cone { cone2 }
    cone { cone3 }
    cone { cone4 }
    cone { cone5 }
  }
      
// Define the complete scene

cone { cone1 }
composite { cones }
composite { cones rotate z*45 translate z*20 }
