// Fantasy Image
// Scene by: Craig Lindley
// Last Update: 09/27/06

#include "colors.inc"
#include "stones.inc"
#include "textures.inc" 
#include "woods.inc" 
#include "skies.inc"

// Camera - perspective (default) camera
camera {
   location <0,0,-90>
   look_at <0,0,0>
   right     x*image_width/image_height
}

// Light source
light_source {
  <0,0,-100>
  color White
}

#declare day_sky = 
  object {
    sphere { 
      <0,0,0> 
      2000
      hollow
     }
     texture {
       pigment {
         gradient y
         pigment_map {
           [0.00 rgb <0.847, 0.749, 0.847> ] // horizon
           [0.10 SkyBlue ]                   // horizon
           [0.20 P_Cloud4 ]
         }
       }
       scale <500,1500,500>  
     }
     finish { ambient .3 diffuse .4 }
  }

#declare rear_box_x = 40;
#declare rear_box_y = 25;
#declare rear_box_z = 2;

#declare rear_box = 
box {
  <-rear_box_x/2,-rear_box_y/2,-rear_box_z/2>
  < rear_box_x/2, rear_box_y/2, rear_box_z/2>
}

#declare road_box_x = 20;
#declare road_box_y = 2;
#declare road_box_z = 10000;

#declare a_finish =
  finish {
    specular 1
    brilliance 10
    phong 10
    phong_size 100
    ambient 0.3
    diffuse 0.8
    reflection 0.3
  }
  

#declare road_box = 
box {
  <-road_box_x/2,-road_box_y/2,-road_box_z/2>
  < road_box_x/2, road_box_y/2, road_box_z/2>
}

#declare framed_road = 
  object {
    union { 
      box {
        road_box
        texture { normal { ripples 10 } pigment { Gray10 } scale 8 }
        finish { a_finish }
      }
      box { 
        road_box
        scale .95
        translate <0,1,0>
        texture {
          pigment { Jade } 
          normal { bumps 0.3 }
          finish { a_finish }
          scale 30 
        }
      }

      box { 
        road_box
        scale x*0.04
        translate <0,1.001,0>
        texture {
          pigment { color Yellow } 
          finish { a_finish }
          scale .4  
        }
      }
    }
}

// Actual scene

object { day_sky translate y*400}

object { framed_road rotate -x*15 rotate  y*15 translate <-20, 0, 0> }
object { framed_road rotate -x*15 rotate -y*15 translate < 20, 0, 0> }
object { framed_road rotate  x*15 rotate  y*15 translate <-20, 0, 0> }
object { framed_road rotate  x*15 rotate -y*15 translate < 20, 0, 0> }


