// Fantasy Image
// Scene by: Craig Lindley
// Last Update: 08/24/06

#include "colors.inc"
#include "stones.inc"
#include "textures.inc" 
#include "woods.inc"

global_settings { 
  assumed_gamma 2.2 
}

// Camera - perspective (default) camera
camera {
   location <0,0,-90>
   look_at <0,0,0>
   right     x*image_width/image_height
}

// Light source
light_source {
  <0,0,-100>
  color White
}

// Define star texture
#declare nite_sky = object {
  plane { <0,0,1> 5000 }
  texture {
    pigment {
      granite
      color_map {
        [0.00 0.76 color Black  color Black]
        [0.80 0.82 color Gray20 color Gray40]
        [0.82 0.84 color Gray40 color Gray60]
        [0.84 0.86 color Gray60 color Gray80]
        [0.86 0.88 color Gray80 color Gray95]
        [0.88 0.91 color Gray95 color White]
        [0.91 1.00 color Black  color Black]
      }
      scale 200
    }
    finish { ambient 1 diffuse 0 }
  }
}

#declare road_box_x = 20;
#declare road_box_y = 2;
#declare road_box_z = 10000;

#declare road_box_finish =
  finish {
    specular 0.5
    roughness 0.001
    ambient .1
    diffuse .5
    reflection { 0.1 }
  }
  

#declare road_box = 
box {
  <-road_box_x/2,-road_box_y/2,-road_box_z/2>
  < road_box_x/2, road_box_y/2, road_box_z/2>
}

#declare framed_road = 
  object {
    union { 
      box {
        road_box
          texture { normal { ripples 5} pigment { Gray10 } }
          finish { road_box_finish }
      }
      box { 
        road_box
        scale .95
        translate <0,1,0>
        texture {
          pigment { Jade } 
          finish { road_box_finish ambient .5 }
          scale 30 
        }
      }

      box { 
        road_box
        scale x*0.04
        translate <0,1.001,0>
        texture {
          pigment { color Yellow } 
          normal { bumps 0.3 }
          finish { road_box_finish ambient .5 }
          scale .4  
        }
      }
    }
}

// Actual scene

object { nite_sky }

object { framed_road rotate -x*15 rotate  y*15 translate <-20, 0, 0> }
object { framed_road rotate -x*15 rotate -y*15 translate < 20, 0, 0> }
object { framed_road rotate  x*15 rotate  y*15 translate <-20, 0, 0> }
object { framed_road rotate  x*15 rotate -y*15 translate < 20, 0, 0> }
