// Fantasy Image
// Scene by: Craig Lindley
// Last Update: 08/24/06

#include "colors.inc"
#include "stones.inc"
#include "textures.inc" 
#include "woods.inc"

global_settings { 
  assumed_gamma 2.2 
}

// Camera - perspective (default) camera
camera {
   location <0,0,-90>
   look_at <0,0,0>
   right     x*image_width/image_height
}

light_source {
  <40,-100,-200>
  color White
}
   
// Define star texture
#declare nite_sky = object {
  sphere { <0,0,0> 5000 hollow }
  texture {
    pigment {
      granite
      color_map {
        [0.00 0.76 color Black  color Black]
        [0.80 0.82 color Gray20 color Gray40]
        [0.82 0.84 color Gray40 color Gray60]
        [0.84 0.86 color Gray60 color Gray80]
        [0.86 0.88 color Gray80 color Gray95]
        [0.88 0.91 color Gray95 color White]
        [0.91 1.00 color Black  color Black]
      }
      scale 200
    }
    finish { ambient 1 diffuse 0 }
  }
}

#declare road_box_x = 20;
#declare road_box_y = 2;
#declare road_box_z = 10000;

#declare road_box_finish =
  finish {
    specular 0.5
    roughness 0.001
    ambient .1
    diffuse .5
    reflection { 0.85 }
  }
  

#declare road_box = 
box {
  <-road_box_x/2,-road_box_y/2,-road_box_z/2>
  < road_box_x/2, road_box_y/2, road_box_z/2> 
  no_shadow
}

#declare framed_road = 
  object {
    union { 
      box {
        road_box
        texture { T_Stone27 scale 70 normal { bumps 250} }
        finish { road_box_finish }
      }
      box { 
        road_box
        scale .95
        translate <0,1,0>
        texture {
          T_Stone27 
          finish { road_box_finish ambient .5 }
          scale 30 
        }
      }

      box { 
        road_box
        scale x*0.04
        translate <0,1.001,0>
        texture {
          pigment { color Blue } 
          normal { bumps 0.3 }
          finish { road_box_finish ambient .5 }
          scale .4  
        }
      }
    }
}

// Actual scene

object { nite_sky }

#declare pad = 30;
#declare pad2 = 15;

object { framed_road rotate  z*0   translate <+00,       -10 - pad, 0> }
object { framed_road rotate -z*45  translate <-10 - pad2,-10 - pad2,0> }
object { framed_road rotate -z*90  translate <-10 - pad,   0,       0> }
object { framed_road rotate -z*135 translate <-10 - pad2, 10 + pad2,0> }
object { framed_road rotate -z*180 translate <+00       , 10 + pad, 0> }
object { framed_road rotate -z*225 translate <+10 + pad2, 10 + pad2,0> }
object { framed_road rotate -z*270 translate <+10 + pad,   0,       0> }
object { framed_road rotate -z*315 translate <+10 + pad2,-10 - pad2,0> }
