// Fantasy Image
// Scene by: Craig Lindley
// Last Update: 08/26/06

#include "colors.inc"
#include "stones.inc"
#include "textures.inc" 

global_settings { 
  assumed_gamma 2.2 
}

// Camera - perspective (default) camera
camera {
   location <0,0,-90>
   look_at <0,0,0>
   right     x*image_width/image_height
}

light_source {
  <40,-100,-200>
  color White
}
   
// Define star texture
#declare nite_sky = object {
  sphere { <0,0,0> 5000 hollow }
  texture {
    pigment {
      granite
      color_map {
        [0.00 0.76 color Black  color Black]
        [0.80 0.82 color Gray20 color Gray40]
        [0.82 0.84 color Gray40 color Gray60]
        [0.84 0.86 color Gray60 color Gray80]
        [0.86 0.88 color Gray80 color Gray95]
        [0.88 0.91 color Gray95 color White]
        [0.91 1.00 color Black  color Black]
      }
      scale 200
    }
    finish { ambient 1 diffuse 0 }
  }
}

#declare road_box_x = 20;
#declare road_box_y = 8;
#declare road_box_z = 10000;

#declare road_box_finish =
  finish {
    specular 0.5
    roughness 0.001
    ambient .2
    diffuse .7
    reflection { 0.75 }
  }
  

#declare road_box = 
box {
  <-road_box_x/2,-road_box_y/2,-road_box_z/2>
  < road_box_x/2, road_box_y/2, road_box_z/2> 
  no_shadow
}

#declare road = 
  object {
    box {
      road_box
      texture {
        pigment {
          mandel 50
          interior 1,5
          color_map {
            [0 rgb <.4,.2,.1>]
            [.3 rgb <.8,.4,.1>]
            [.6 rgb <1,.8,.4>]
            [1 rgb 1]
          }
        }
        normal {
          mandel 80 1
          interior 1,5
          slope_map {
            [0 <0,0>]
            [.5 <.5,1>]
            [1 <1,0>] 
          }
        }
        finish { specular 1 reflection .5 }
        translate <.2,0>
        scale 150
        rotate x*90
      }
      finish { road_box_finish }
    }
  }


// Actual scene

object { nite_sky }

#declare pad = 30;
#declare pad2 = 15;

object { road rotate  z*0   translate <+00,       -10 - pad, 0> }
object { road rotate -z*45  translate <-10 - pad2,-10 - pad2,0> }
object { road rotate -z*90  translate <-10 - pad,   0,       0> }
object { road rotate -z*135 translate <-10 - pad2, 10 + pad2,0> }
object { road rotate -z*180 translate <+00       , 10 + pad, 0> }
object { road rotate -z*225 translate <+10 + pad2, 10 + pad2,0> }
object { road rotate -z*270 translate <+10 + pad,   0,       0> }
object { road rotate -z*315 translate <+10 + pad2,-10 - pad2,0> }
