// Glass Marbles

// Written by: Craig Lindley
// Last update: 07/30/2006


// Includes
#include "colors.inc"	  // Standard Color definitions
#include "textures.inc"	  // Standard Texture definitions
#include "glass.inc"      // Definition of various glasses
#include "stones.inc"

#default {
    finish {
        specular 0.35
        roughness 0.005
    }
}

// Camera - perspective (default) camera
camera {
  location  <0.0, 0.0, -42.0>
  look_at   <0.0, 0.0,  0.0>
  right     x*image_width/image_height
}

// Light sources

// general light definition
light_source {
  <0, 0, -100>      // position of the light source
  color rgb 1.0     // color of the light
}


#declare F_Glass =
  finish {
    specular 0.7
    roughness 0.001
    ambient 0
    diffuse .2
    reflection { 0.4 }
  }

// Scene definition

// Background

// A plane with a stone finish
plane {
  z,
  100.0
  texture { T_Stone28 finish { F_Glass } scale 50 }  
}

#declare tex = texture { pigment { color Col_Glass_Clear } finish { F_Glass } }
#declare mat = material { texture { tex } interior { I_Glass fade_color Col_Amethyst_06 } }

#declare columns=5;
#declare rows=5; 
#declare space=10;

#declare xoffset=((columns-1)* space) / 2;
#declare yoffset=((rows-1)* space) / 2;

#declare marble_radius=3;
#declare amarble=sphere { <0, 0, 0> marble_radius material { mat } }

#declare row=0;
   #while (row < rows)          

      #declare column=0;
      
      #while (column < columns)
         object { amarble translate <(column*space) - xoffset, (row*space) - yoffset, 0>}
      
         #declare column=column+1;
      #end
      #declare row=row+1;
   #end          
      
