// Arches in Water
// Scene by: Craig Lindley
// Last Update: 08/28/06

#include "colors.inc"
#include "shapes.inc"
#include "metals.inc"
#include "skies.inc"

// Define the camera
camera {
  fisheye
  location <10,-9,-20>
  right x*image_width/image_height
  look_at <0,-6,0> 
}

// Define the light source
light_source {
  <0,0,150>
  color White
}

// Define the sky
#declare blue_sky = 
  sky_sphere { S_Cloud2 }


// Define the ocean
#declare ocean = 
  plane {
    y, -10.0
    texture {
      T_Chrome_2D
      normal {
        waves 0.05
        frequency 5000.0
        scale 300.0
      }
    }
  }


// Define the arches
#declare arch =  
  object {
    difference {
      object {
        Paraboloid_Y
        scale <20.0, 20.0, 5.0>
        rotate 180*x
        texture { T_Chrome_3C }
      }
      object {
        Paraboloid_Y
        scale <18.0, 20.0, 18.0>
        rotate 180*x
        translate -2*y
        texture { T_Copper_3C }
      }
    }
    scale <.5,2,-0.3>
  }

  
  
// Define the complete image
sky_sphere { blue_sky }
plane { ocean }

#declare arch_count = 2;
#declare arch_offset = 20;

#declare total_count = 0;
#declare total_offset = -10;

#while (total_count <= arch_count ) 

  object { arch translate z*total_offset }
  #declare total_offset = total_offset + arch_offset; 
  #declare total_count = total_count + 1;  

#end





