// Arches in Water
// Scene by: Craig Lindley
// Last Update: 08/28/06

#include "colors.inc"
#include "shapes.inc"
#include "metals.inc"
#include "skies.inc" 
#include "stones.inc"

// Define the camera
camera {
  ultra_wide_angle
  location <10,-9,-20>
  right x*image_width/image_height
  look_at <0,-6,0> 
}

// Define the light source
light_source {
  <-20,10,-150>
  color White
}

// Define star texture
#declare nite_sky = object {
  sphere { <0,0,0> 5000 hollow }
  texture {
    pigment {
      granite
      color_map {
        [0.00 0.76 color Black  color Black]
        [0.80 0.82 color Gray20 color Gray40]
        [0.82 0.84 color Gray40 color Gray60]
        [0.84 0.86 color Gray60 color Gray80]
        [0.86 0.88 color Gray80 color Gray95]
        [0.88 0.91 color Gray95 color White]
        [0.91 1.00 color Black  color Black]
      }
      scale 200
    }
    finish { ambient 1 diffuse 0 }
  }
}

// Define the ocean
#declare ocean = 
  plane {
    y, -10.0
    texture {
      T_Chrome_2D
      normal {
        waves 0.05
        frequency 5000.0
        scale 3000.0
      }
    }
  }


#declare arch_finish = 
  finish {
    reflection 0.4
    brilliance 40
    phong 0.9
    phong_size 100
    ambient .25
    diffuse .75
  }

#declare arch_texture =
  texture {
    T_Stone27
    scale 20
    finish { arch_finish }
  }

// Define the arches
#declare arch =  
  object {
    difference {
      object {
        Paraboloid_Y
        scale <20.0, 20.0, 5.0>
        rotate 180*x
      }
      object {
        Paraboloid_Y
        scale <18.0, 20.0, 18.0>
        rotate 180*x
        translate -2*y
      }
      texture { arch_texture }
    }
    scale <.5,2,-0.3>
  }

  
  
// Define the complete image
object { nite_sky }
plane { ocean }

#declare arch_count = 100;
#declare arch_offset = 20;

#declare total_count = 0;
#declare total_offset = -10;

#while (total_count <= arch_count ) 

  object { arch translate z*total_offset }
  #declare total_offset = total_offset + arch_offset; 
  #declare total_count = total_count + 1;  

#end





