// More reflecting spheres
// Scene by: Craig Lindley
// Last Update: 09/18/06

#include "colors.inc"

global_settings { 
  max_trace_level 50 
  max_intersections 128
}

// Define the camera
camera {
  location <2,-2,2>
  right x*image_width/image_height
  angle 12
  look_at <0,0,0>
}

// Define the light sources
light_source {
   <-3,-3,-3>
   color Blue
}
light_source {
   <-3,3,3>
   color Gold
}
light_source {
   <3,3,-3>
   color Blue
}

   
#declare sphere_color =
  color Gold;
     
// Highly reflective finish
#declare sphere_finish =

finish {
  ambient 0.1
  diffuse 1
  brilliance 100
  specular 1
  reflection 1
  phong 100 
  phong_size 200
  metallic
}


// Define the four spheres
#declare sphere1 =
  sphere {
    <-0.5,-0.5,0.5>, 0.707
    texture {
      pigment {
        sphere_color
      }
      finish {
        sphere_finish
      }
    }
  }

#declare sphere2 = 
  sphere {
    <0.5,0.5,0.5>, 0.707
    texture {
      pigment {
        sphere_color
      }
      finish {
        sphere_finish
      }
    }
  }

#declare sphere3 = 
  sphere {
    <-0.5,0.5,-0.5>, 0.707
    texture {
      pigment {
        sphere_color
      }
      finish {
        sphere_finish
      }
    }
  }

#declare sphere4 = 
  sphere {
    <0.5,-0.5,-0.5>, 0.707
    texture {
      pigment {
        sphere_color
      }
      finish {
        sphere_finish
      }
    }
  }
  
// Define the complete scene
sphere { sphere1 }
sphere { sphere2 }
sphere { sphere3 }
sphere { sphere4 }
